## pingus 0.7.6

=== Makefile ===
##  Pingus - A free Lemmings clone
##  Copyright (C) 2010 Ingo Ruhnke <grumbel@gmx.de>
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##  
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##  
##  You should have received a copy of the GNU General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.

DESTDIR = 
PREFIX  = /usr/local
DATADIR = $(PREFIX)/share/pingus
MANDIR  = $(PREFIX)/share/man
BINDIR  = $(PREFIX)/bin

build/pingus:
	mkdir -p build
	scons src
	scons
	ln -fs build/pingus

clean:
	rm -rf .sconf_temp/
	rm -f .sconsign.dblite
	rm -rf build/
	rm -f pingus
	scons -c

install: install-exec install-data install-man

install-exec: build/pingus
	install -d "$(DESTDIR)$(BINDIR)"

	install -D build/pingus "$(DESTDIR)$(BINDIR)/pingus.bin"
	echo -e "#!/bin/sh\nexec \"$(BINDIR)/pingus.bin\" --datadir \"$(DATADIR)\"" > "$(DESTDIR)$(BINDIR)/pingus"
	chmod 755 "$(DESTDIR)$(BINDIR)/pingus"

install-data:
	cd data/ && \
	find . \
        -type f -a  \( \
        -name "*.png" -o \
        -name "*.jpg" -o \
        -name "*.wav" -o \
        -name "*.scm" -o \
        -name "*.font" -o \
        -name "*.story" -o \
        -name "*.credits" -o \
        -name "*.prefab" -o \
        -name "*.it" -o \
        -name "*.ogg" -o \
        -name "*.s3m" -o \
        -name "*.po" -o \
        -name "*.worldmap" -o \
        -name "*.res" -o \
        -name "*.pingus" -o \
        -name "*.levelset" -o \
        -name "*.sprite" \
        \) -exec install -D {} $(DESTDIR)$(DATADIR)/{} \;

install-man:
	install -D doc/man/pingus.6 "$(DESTDIR)$(MANDIR)/man1/pingus.6"

.PHONY : clean install install-exec install-data install-man

# EOF #

=== SConstruct ===
# -*- mode: python -*-

import os

with open("VERSION", "r") as fin:
    package_version = fin.readline().strip()
    
Export("package_version")
SConscript('SConscript', variant_dir='build', duplicate=0)

# EOF #

=== doc/man/Makefile ===
all: pingus.6

%.6: %.xml Makefile
	echo "<!ENTITY pingus_version \"$$(cat ../../VERSION)\">" > pingus.ent
	db2x_xsltproc --stylesheet man "$<" | db2x_manxml
	xmlto xhtml -o pingus.html -m config.xsl pingus.xml
	mv -v pingus.html/index.html pingus.html/index.orig.html
	tidy -q -utf8 -indent -wrap 1000  -o pingus.html/index.html pingus.html/index.orig.html
#	docbook2x-texi --output-dir "../build/doc/" "$<"
#        MANWIDTH=80 man -l pingus.1

# EOF #

=== external/tinygettext/CMakeLists.txt ===
#
# TinyGetText build script
# Copyright (C) 2006 Christoph Sommer <christoph.sommer@2006.expires.deltadevelopment.de>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#


#
# INSTRUCTIONS:
# -------------
#
# Create a directory build/ and change to it. Run
#
#   cmake ..
#
# This creates a set of Makefiles to build the project. Run
#
#   make
#


CMAKE_POLICY(SET CMP0005 NEW)

## Project name to use as command prefix

PROJECT(tinygettext)
SET(VERSION "0.1")

### CMake configuration

CMAKE_MINIMUM_REQUIRED(VERSION 2.4)
IF(COMMAND cmake_policy)
	CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND cmake_policy)
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${tinygettext_SOURCE_DIR})

# move some config clutter to the advanced section
MARK_AS_ADVANCED(
	CMAKE_BACKWARDS_COMPATIBILITY
	CMAKE_BUILD_TYPE
	CMAKE_INSTALL_PREFIX
	EXECUTABLE_OUTPUT_PATH
	CMAKE_OSX_ARCHITECTURES
	CMAKE_OSX_SYSROOT
)

## Reveal library type choice to users
OPTION(BUILD_SHARED_LIBS "Produce dynamic library instead of static archive" ON)

## Add iconv to include directories

FIND_PACKAGE(ICONV REQUIRED)
INCLUDE_DIRECTORIES(${ICONV_INCLUDE_DIR})

## Check iconv_const

INCLUDE(CheckCXXSourceCompiles)

SET(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} ${ICONV_INCLUDE_DIR})
CHECK_CXX_SOURCE_COMPILES(
	"
	#include <iconv.h>
	// this declaration will fail when there already exists a non const char** version which returns size_t
	double iconv(iconv_t cd,  char **inbuf, size_t *inbytesleft, char **outbuf, size_t *outbytesleft);
	int main() { return 0; }
	"
	HAVE_ICONV_CONST
)

# TODO: better way of config

IF(HAVE_ICONV_CONST)
  ADD_DEFINITIONS(-DHAVE_ICONV_CONST)
ELSE(HAVE_ICONV_CONST)
  REMOVE_DEFINITIONS(-DHAVE_ICONV_CONST)
ENDIF(HAVE_ICONV_CONST)

## TinyGetText library compilation

## build list of source files

FILE(GLOB TINYGETTEXT_SOURCES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} tinygettext/*.cpp)
FILE(GLOB TINYGETTEXT_HEADERS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} tinygettext/*.hpp)

## define a target for building the library

ADD_LIBRARY(tinygettext ${TINYGETTEXT_SOURCES})

## Add tinygettext dir to search path

INCLUDE_DIRECTORIES(${tinygettext_SOURCE_DIR})

## Debug options

OPTION(WERROR "Stops on first compiler warning in debug mode" OFF)
IF(CMAKE_COMPILER_IS_GNUCC)
  ADD_DEFINITIONS(-O3 -Wall -Wextra -Weffc++ -pedantic) 
  # -ansi fails in MinGW
  OPTION(WARNINGS "Enable long list of warnings for compiler to check" ON)
  IF(WARNINGS)
    ADD_DEFINITIONS(
          -Wabi  -Wctor-dtor-privacy
          -Wstrict-null-sentinel
          -Wold-style-cast
          -Woverloaded-virtual
          -Wsign-promo -Wswitch-enum
          -Wcast-align  -Wcast-qual
          -Wdisabled-optimization
          -Wfloat-equal  
          -Wformat=2
          -Winit-self 
          -Winvalid-pch  -Wunsafe-loop-optimizations
          -Wlogical-op 
          -Wmissing-format-attribute  -Wmissing-include-dirs -Wmissing-noreturn 
          -Wpacked
          -Wredundant-decls
          -Wshadow
          -Wsign-conversion  -Wstack-protector
          -Wstrict-overflow=5
          -Wswitch-default  -Wswitch-enum
          -Wundef)
        # Still left:
        # -Wconversion  (find alternative to using toupper(int) on char)
        # -Wpadded      (DictionaryManager has a bool that sticks out)
  ENDIF(WARNINGS)
  IF(WERROR)
    ADD_DEFINITIONS(-Werror)
  ENDIF(WERROR)
ENDIF(CMAKE_COMPILER_IS_GNUCC)

## Extra definitions

ADD_DEFINITIONS(-DVERSION=\\\"${VERSION}\\\")

## Generate test executables in the right place

SET(EXECUTABLE_OUTPUT_PATH ${tinygettext_BINARY_DIR}/test)

## Build tinygettext tests

FOREACH(TEST tinygettext_test po_parser_test)
  ## Add target for tinygettext test
  ADD_EXECUTABLE(${TEST} test/${TEST}.cpp)
  ## Link with tinygettext library
  TARGET_LINK_LIBRARIES(${TEST} tinygettext)
  TARGET_LINK_LIBRARIES(${TEST} ${ICONV_LIBRARY})
ENDFOREACH(TEST)

## Install tinygettext

# use standardized variable name
SET(LIB_SUBDIR "lib${LIB_SUFFIX}"
	CACHE STRING "Subdirectory of prefix into which libraries are installed (e.g., lib32, lib64)")

## prepare tinygettext.pc
CONFIGURE_FILE(tinygettext.pc.in tinygettext.pc @ONLY)

INSTALL(TARGETS tinygettext
	ARCHIVE DESTINATION ${LIB_SUBDIR}
	LIBRARY DESTINATION ${LIB_SUBDIR})
INSTALL(FILES ${TINYGETTEXT_HEADERS}
	DESTINATION include/tinygettext)
INSTALL(FILES ${tinygettext_BINARY_DIR}/tinygettext.pc
	DESTINATION ${LIB_SUBDIR}/pkgconfig)

=== external/tinygettext/SConstruct ===
# -*- python -*-

env = Environment(CXXFLAGS=['-O0',
                            '-g3',
                            '-Wall',
                            '-Wcast-qual',
                            '-Wconversion',
                            '-Weffc++',
                            '-Werror',
                            '-Wextra',
                            '-Winit-self',
                            '-Wno-unused-parameter',
                            '-Wnon-virtual-dtor',
                            '-Wshadow',
                            '-ansi',
                            '-pedantic',
                            ],
                  CPPPATH=['tinygettext', '.'])

# env.ParseConfig("sdl-config --cflags --libs")
# env['CPPDEFINES'] += HAVE_SDL

libtinygettext = env.StaticLibrary('tinygettext/tinygettext', 
                                   ['tinygettext/tinygettext.cpp',
                                    'tinygettext/language.cpp',
                                    'tinygettext/plural_forms.cpp',
                                    'tinygettext/dictionary.cpp',
                                    'tinygettext/dictionary_manager.cpp',
                                    'tinygettext/unix_file_system.cpp',
                                    'tinygettext/po_parser.cpp',
                                    'tinygettext/iconv.cpp',
                                    'tinygettext/log.cpp'])

env.Program('test/tinygettext_test', ['test/tinygettext_test.cpp', libtinygettext])
env.Program('test/po_parser_test', ['test/po_parser_test.cpp', libtinygettext])

# EOF #

=== debian/changelog ===
pingus (0.7.6-7) unstable; urgency=medium

  * Team upload.
  * Build with GCC-15 (Closes: #1097592)
  * Drop kfreebsd hybridation
  * Add debian/salsa-ci.yml
  * Bump Standards-Version to 4.7.2
  * Drop "Rules-Requires-Root: no", it is the new default
  * Update Miriam email address

  [ Patrice Duroux ]
  * Point to the new Pingus homepage. Closes: #1070248.

 -- Alexandre Detiste <tchet@debian.org>  Sat, 13 Sep 2025 11:02:10 +0200

pingus (0.7.6-6) unstable; urgency=medium

  * Team upload.

  [ Alexandre Detiste ]
  * fix FTBFS with GCC-13 (Closes: #1037820)
  * set Rules-Requires-Root: no

  [ Patrice Duroux ]
  * build with libboost>=1.69 (Closes: #1036716)

  [ lintian-brush ]
  * Trim trailing whitespace.
  * Strip unusual field spacing from debian/control.
  * Bump debhelper from old 10 to 13.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Fix day-of-week for changelog entries 0.7.1-1, 0.7.0-2, 0.2.1-1.

 -- Alexandre Detiste <alexandre.detiste@gmail.com>  Fri, 23 Jun 2023 21:05:26 +0200

pingus (0.7.6-5) unstable; urgency=medium

  * Team upload.
  * Added: scons-use-python3-print.patch. (Closes: #947574).
  * d/control: Update 'Vcs-Browser' and 'Vcs-Git'.
  * d/control: Update 'Standards-Version'.

 -- Phil Wyett <philip.wyett@kathenas.org>  Sun, 29 Dec 2019 09:24:25 +0000

pingus (0.7.6-4) unstable; urgency=medium

  * Team upload.
  * Switch to compat level 10.
  * Declare compliance with Debian Policy 4.1.0.
  * Drop deprecated menu file and xpm icon.
  * Add gcc7.patch and fix FTBFS with GCC 7. (Closes: #853614)

 -- Markus Koschany <apo@debian.org>  Thu, 24 Aug 2017 19:02:22 +0200

pingus (0.7.6-3) unstable; urgency=medium

  * Team upload.

  [ Bertrand Marc ]
  * Update watch file. Pingus has moved to Github.

  [ Markus Koschany ]
  * Declare compliance with Debian Policy 3.9.6.
  * Vcs-Browser: Use https.
  * debian/rules: Replace deprecated dh_clean -k with dh_prep.
  * Add more-updated-German-translation.patch.
    Thanks to Helge Kreutzmann for the report and patch. (Closes: #764522)
  * Fix Lintian warning copyright-refers-to-symlink-license.
  * pingus.desktop: Add keywords to desktop file.
  * Use compat level 9 and require debhelper >= 9.
  * pingus-data: Only suggest pingus and let people install the data without
    pulling in the engine as well.

 -- Markus Koschany <apo@debian.org>  Mon, 28 Dec 2015 00:37:46 +0100

pingus (0.7.6-2) unstable; urgency=low

  [ Bertrand Marc ]
  * Acknowledge NMU from Matej Vela, thanks for the quick fix.
  * Add a german comment in pingus.desktop, thanks to Ronny Standtke
    (Closes: #667673).
  * Update the german translation, thanks to Helge Kreutzmann (Closes: #722887).
  * Update standards version to 3.9.5: no changes needed.
  * Enable hardening build flags in debian/rules.
  * Add debian/patches/mutliple_buildflags.diff to allow multiple buildflags to
    be passed to scons.
  * Remove options.cache and its logic in debian/rules as scons doesn't use it.

  [ Evgeni Golov ]
  * Correct Vcs-* URLs to point to anonscm.debian.org

  [ Jackson Doak ]
  * Move lintian overrides to debian/pingus-data.lintian-overrides

  [ Cyril Brulebois ]
  * Remove myself from Uploaders.

 -- Bertrand Marc <beberking@gmail.com>  Sun, 10 Aug 2014 14:59:56 +0200

pingus (0.7.6-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * 20_gcc_4.7: Fix build failure with GCC 4.7.  Closes: #673389.
    - src/pingus/pingus_main.cpp, src/pingus/screens/pingus_menu.cpp:
      Add whitespace between string literals and macros.

 -- Matej Vela <vela@debian.org>  Sat, 19 May 2012 11:21:44 +0100

pingus (0.7.6-1) unstable; urgency=low

  * New upstream release.

 -- Bertrand Marc <beberking@gmail.com>  Mon, 26 Dec 2011 16:35:39 +0100

=== debian/control ===
Source: pingus
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Miriam Ruiz <miriam@debian.org>,
 Bertrand Marc <bmarc@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 libboost-dev,
 libphysfs-dev,
 libsdl-image1.2-dev,
 libsdl-mixer1.2-dev,
 libsdl1.2-dev,
 scons,
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/games-team/pingus
Vcs-Git: https://salsa.debian.org/games-team/pingus.git
Homepage: https://pingus.github.io/

Package: pingus
Architecture: any
Depends:
 pingus-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Free Lemmings(TM) clone
 Pingus is a free clone of the popular Lemmings game.
 .
 Your goal is to guide a horde of penguins through a world full of obstacles
 and penguin traps to safety. Although penguins (unlike lemmings) are rather
 smart, they sometimes lack the necessary overview and now rely on you to
 save them.
 .
 This package contains the main program.

Package: pingus-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Suggests:
 pingus,
Description: Data files for pingus, a free Lemmings(TM) clone
 Pingus is a free clone of the popular Lemmings game.
 .
 Your goal is to guide a horde of penguins through a world full of obstacles
 and penguin traps to safety. Although penguins (unlike lemmings) are rather
 smart, they sometimes lack the necessary overview and now rely on you to
 save them.
 .
 This package contains the data files.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

configure: configure-stamp
configure-stamp:
	dh_testdir
	touch $@

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp: configure-stamp
	dh_testdir
	scons $(SCONS_OPTS) CPPFLAGS='$(CPPFLAGS)' CXXFLAGS='$(CXXFLAGS)' \
		LINKFLAGS='$(LDFLAGS)'
	touch $@

clean: clean-patched
	dh_testdir
	dh_testroot
	dh_clean

clean-patched:
	dh_testdir
	dh_testroot
	scons -c CPPFLAGS='$(CPPFLAGS)' CXXFLAGS='$(CXXFLAGS)' \
		LINKFLAGS='$(LDFLAGS)'
	rm -f build-stamp configure-stamp
	rm -f config.log .sconsign.dblite
	rm -rf .sconf_temp build/

install: build
	dh_testdir
	dh_testroot
	dh_prep -a
	dh_installdirs

# Build architecture-independent files here.
binary-indep:
	dh_testdir
	dh_testroot
	dh_prep -i
	dh_installchangelogs -i NEWS
	dh_installdocs -i --exclude=pingus.6

	mkdir -p "$(CURDIR)/debian/pingus-data/usr/share/games/pingus/"
	find data/ \
        -type f -a  \( \
        -name "*.png" -o \
        -name "*.jpg" -o \
        -name "*.wav" -o \
        -name "*.scm" -o \
        -name "*.font" -o \
        -name "*.story" -o \
        -name "*.credits" -o \
        -name "*.prefab" -o \
        -name "*.it" -o \
        -name "*.ogg" -o \
        -name "*.s3m" -o \
        -name "*.po" -o \
        -name "*.worldmap" -o \
        -name "*.res" -o \
        -name "*.pingus" -o \
        -name "*.levelset" -o \
        -name "*.sprite" \
		\) -exec cp --parents -v {} "$(CURDIR)/debian/pingus-data/usr/share/games/pingus/" \;

	dh_install -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i


# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs -a NEWS
	dh_installdocs -a --exclude=man/* --exclude=html/*
	dh_installexamples -a
	dh_install -a
	dh_installmenu -a
	dh_installman -a doc/man/pingus.6
	dh_link -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
#	dh_makeshlibs -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%" \
  https://github.com/Pingus/@PACKAGE@/tags (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@
